#include "http.h"
#include "getopt.h"
#include "utils.h"
#include "bgi_lib.h"
#include "builtin.h"

#include <sys/resource.h>
#include <signal.h>


thread_t listen_id;
http_daemon* listen_thread;

/* hack */
char** glob_argv;
int glob_argc;
int secret_socket;

int main(int argc, char** argv) {

  glob_argc = argc;
  glob_argv = argv;
  struct rlimit foo;
  getrlimit(RLIMIT_NOFILE,&foo);
  foo.rlim_cur= foo.rlim_max;
  if(setrlimit(RLIMIT_NOFILE,&foo) <0) {
    perror("setrlimit:");
  }

  int port=80;
  secret_socket=-1;
  char config_file[1024];
  char root[1024];
  char mime_tab[1024];
  char log_tab[1024];
  strcpy(config_file,DEFAULT_FS_TAB);
  strcpy(root,DEFAULT_ROOT_DIR);
  strcpy(mime_tab,DEFAULT_MIME_TAB);
  strcpy(log_tab,DEFAULT_LOG_TAB);
  
  int c;

  while ((c = getopt(argc,argv,"p:f:m:r:dl:S")) >0) {
    switch(c) {
    case 'l':
      strcpy(log_tab,optarg);
      break;
    case 'p':
      port = atoi(optarg);
      break;
    case 'f':
      strcpy(config_file,optarg);
      break;
    case 'm':
      strcpy(mime_tab,optarg);
      break;
    case 'r':
      strcpy(root,optarg);
      break;
    case 'd':
      debug++;
      break;
    case 'S':
      secret_socket=0;
      break;
    default:
      fprintf(stderr,
      "usage: httpd [-p port] [-f config_file] [ -r root ] [ -m mime_file ]\n");
      exit(1);
    }
  }

  current_configuration = new http_configuration();
  if(current_configuration->load_configuration(config_file,mime_tab,
					       root,log_tab,port) <0) {
    printf("couldn't configure - exiting\n");
    exit(1);
  }

  sigignore(SIGPIPE);
  
  listen_thread = (new http_daemon(current_configuration,secret_socket));
  listen_id = start_thread(listen_thread);
  thr_exit(0);
  return 0;
}
